rule win_unidentified_030_auto {

    meta:
        author = "Felix Bilstein - yara-signator at cocacoding dot com"
        date = "2018-11-23"
        version = "1"
        description = "autogenerated rule brought to you by yara-signator"
        tool = "yara-signator 0.1a"
        malpedia_reference = "https://malpedia.caad.fkie.fraunhofer.de/details/win.unidentified_030"
        malpedia_version = "20180607"
        malpedia_license = "CC BY-SA 4.0"
        malpedia_sharing = "TLP:WHITE"

    /* DISCLAIMER
     * The strings used in this rule have been automatically selected from the
     * disassembly of memory dumps and unpacked files, using yara-signator.
     * The code and documentation / approach will be published in the near future here:
     * https://github.com/fxb-cocacoding/yara-signator
     * As Malpedia is used as data source, please note that for a given
     * number of families, only single samples are documented.
     * This likely impacts the degree of generalization these rules will offer.
     * Take the described generation method also into consideration when you
     * apply the rules in your use cases and assign them confidence levels.
     */

    strings:
        $sequence_0 = { 76ff d7 c3 76ff }
            // n = 4, score = 1000
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503e

        $sequence_1 = { c3 76ff d7 c3 }
            // n = 4, score = 1000
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 

        $sequence_2 = { d7 c3 76ff d7 }
            // n = 4, score = 1000
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               

        $sequence_3 = { e7ff d7 c3 76ff }
            // n = 4, score = 1000
            //   e7ff                 | out                 -1, eax
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a

        $sequence_4 = { c3 76ff d7 c3 76ff }
            // n = 5, score = 1000
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503e

        $sequence_5 = { d7 c3 76ff d7 c3 }
            // n = 5, score = 1000
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 

        $sequence_6 = { e7ff d7 c3 76ff d7 }
            // n = 5, score = 1000
            //   e7ff                 | out                 -1, eax
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               

        $sequence_7 = { 76ff d7 c3 76ff d7 }
            // n = 5, score = 1000
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503e
            //   d7                   | xlatb               

        $sequence_8 = { e7ff d7 c3 76ff d7 c3 }
            // n = 6, score = 1000
            //   e7ff                 | out                 -1, eax
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 

        $sequence_9 = { d7 c3 76ff d7 c3 76ff }
            // n = 6, score = 1000
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503a
            //   d7                   | xlatb               
            //   c3                   | ret                 
            //   76ff                 | jbe                 0x43503e

    condition:
        7 of them and filesize < 800000
}
